#!/usr/bin/perl
#
# lawrence david - 2006
# ldavid@mit.edu

use strict;
use warnings;

my($cur_app); 
my %app_hash = ();
my($total_count) = 0;
my($frac) = 0.0;
my($minutes) = 0.0;
my($name);

print "\n";
my($delay) = 5;
my($frac_tot) = 0.0;
my($time_tot) = 0.0;

while (1) {

    $frac_tot = 0.0;
    $time_tot = 0.0;    

    $total_count += $delay;

    $cur_app = `osascript frontapp.scpt`;
    $cur_app =~ s/.*:([^:]*):/$1/g;
    $cur_app =~ s/.app//g;
    $app_hash{$cur_app} += $delay;
    system("clear");
    print "app\t\t%\tmins\n";
    print "----------------------------\n";
    while ( my ($k,$v) = each %app_hash ) {
	chomp $k;
	$frac = round2($v/$total_count)*100;
	$minutes = round($v/60);
	$name = substr($k,0,7);
	$time_tot += $minutes;
	$frac_tot += $frac;
	print "$name\t\t$frac\t$minutes\n";
    }
    print "----------------------------\n";
    print "Total\t\t$frac_tot\t$time_tot\n";
    sleep($delay);
}

sub round {
    my($number) = shift;
    return int($number*100)/100;
}

sub round2 {
    my($number) = shift;
    return int($number*1000)/1000;
}
